#include <bits/stdc++.h>
using namespace std;
long long n, sol, x, y, z; long long P[100096]; vector< vector <long long> >D; map <long long, int> m;
int main()
{
  scanf("%lld", &n); D.resize(n+1);
  for(int i = 1; i <= n; i++)
    scanf("%lld", &x), P[x]++;
  for(int i = 1; i <= n; i++)
    scanf("%lld", &y), D[y].push_back(i);
  for(int i = 1; i <= n; i++)
    scanf("%lld", &z), m[z]++;
  for(int i = 1; i <= n; i++)
  {
    int p = D[i].size();
    for(int j = 0; j < p; j++)
      sol += P[i] * m[D[i][j]];
  }
  printf("%lld\n", sol);


  return 0;
}